unit Nelinear_Unit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TControl_Panel = class(TForm)
    ComboBox1: TComboBox;
    EditX1: TEdit;
    EditY1: TEdit;
    EditY2: TEdit;
    EditX2: TEdit;
    LabelNula: TLabel;
    Button1: TButton;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Ukaz_Graf(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Sestroj_Graf(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Control_Panel   :TControl_Panel;
  f,Error         :String;
  NumberOfSegments,HorniHranice:Integer;
  xx,yy           :array [0..100] of Double;
  Citac           :Integer;
  PulA,PulB       :Double;

implementation

uses Graph2d_2005;

var Expression:TExpression;

{$R *.DFM}

Procedure Graf;
Var Error:String;
    Err  :Integer;
begin
  With Draw2D do
  begin
    Val(Control_Panel.Editx1.Text,x1,Err);
    Val(Control_Panel.Editx2.Text,x2,Err);
    Val(Control_Panel.Edity1.Text,y1,Err);
    Val(Control_Panel.Edity2.Text,y2,Err);
    Scale(x1,x2,y1,y2);
    ClearImage(255,255,255);
    xScale(x1,x2,0,200,0,0);
    yScale(y1,y2,0,200,0,0);
    hx:=(x2-x1)/200;
    x:=x1;
    Repeat
      A[1]:=x;A[2]:=Calc(Control_Panel.Combobox1.Text,Error);
      x:=x+hx;
      B[1]:=x;B[2]:=Calc(Control_Panel.Combobox1.Text,Error);
      cvLine(A,B,0,0,200);
    until x>x2;
  end;
end;

procedure TControl_Panel.FormCreate(Sender: TObject);
begin
  Application.CreateForm(TDraw2D, Draw2D);
  With Draw2D do
  begin
    ClientWidth:=650;ClientHeight:=650;
    InitImage(650,650);ClearImage(255,255,255);
    Caption:='Function y=f(x)';
    Visible:=True;
    Left:=400;Top:=40;
    Blue:=200;Green:=0;Red:=0;
  end;
  Combobox1.Text:='2*x^2-8*x+6';
  f:=Combobox1.Text;
  EditX1.Text:='-10';
  EditX2.Text:='10';
  EditY1.Text:='-10';
  EditY2.Text:='10';
  NumberOfSegments:=200;
  Graf
end;

procedure TControl_Panel.Ukaz_Graf(Sender: TObject);
var Error,Citac:Integer;

begin
 Citac:=0;
 Application.ProcessMessages;
   if Combobox1.Text='2*x^2-8*x+6' then Citac:=1;
   if Combobox1.Text='x^3-6*x^2+6*x-1' then Citac:=2;
   if Combobox1.Text='x^4-3*x^3+6*x^2-2' then Citac:=3;
   if Combobox1.Text='exp(5/(x^2+10)+4.5)-100' then Citac:=4;
   if Combobox1.Text='2*(sin(x))^2-(cos(x))^2-4*sin(x)+2.1' then Citac:=5;
   if Combobox1.Text='0.2*x+0.4+3*sin(x)' then Citac:=6;
   if Combobox1.Text='0.15*sqrt(x^2+2)*exp((x-3)/2)-3' then Citac:=7;
   Case Citac of
      1: Begin
           EditX1.Text:='-1';
           EditX2.Text:='4';
           EditY1.Text:='-3';
           EditY2.Text:='10';
           end;
      2: Begin
           EditX1.Text:='-2';
           EditX2.Text:='6';
           EditY1.Text:='-12';
           EditY2.Text:='5';
           end;
      3: Begin
           EditX1.Text:='-1';
           EditX2.Text:='1';
           EditY1.Text:='-3';
           EditY2.Text:='2';
           end;
      4: Begin
           EditX1.Text:='-20';
           EditX2.Text:='20';
           EditY1.Text:='-20';
           EditY2.Text:='50';
           end;
      5: Begin
           EditX1.Text:='-10';
           EditX2.Text:='10';
           EditY1.Text:='-2';
           EditY2.Text:='10';
           end;
      6: Begin
           EditX1.Text:='-10';
           EditX2.Text:='10';
           EditY1.Text:='-10';
           EditY2.Text:='10';
           end;
      7: Begin
           EditX1.Text:='-10';
           EditX2.Text:='10';
           EditY1.Text:='-10';
           EditY2.Text:='10';
           end;
         end;
    f:=Combobox1.Text;
    if Citac>0 then Graf;
end;

procedure TControl_Panel.Button1Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TControl_Panel.Sestroj_Graf(Sender: TObject);
begin
  f:=Combobox1.Text;
  Graf;
end;

end.
