unit Nelinear_Unit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TControl_Panel = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    ComboBox1: TComboBox;
    EditX1: TEdit;
    EditY1: TEdit;
    EditY2: TEdit;
    EditX2: TEdit;
    Editf: TEdit;
    Button1: TButton;
    Button2: TButton;
    LabelNula: TLabel;
    LabelX: TLabel;
    Button3: TButton;
    Button4: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Ukaz_Graf(Sender: TObject);
    procedure Pocitej(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure Setting;
  end;

var
  Control_Panel   :TControl_Panel;
  f,Error         :String;
  NumberOfSegments,HorniHranice:Integer;
  xx,yy           :array [0..100] of Double;
  Citac           :Integer;
  PulA,PulB       :Double;
  Stop            :Boolean;

implementation

uses Graph2d_2005;

var Expression:TExpression;

{$R *.DFM}

procedure TControl_Panel.Setting;
var Number:Double;
    Code:Integer;
    Vypis:String;
begin
    if Combobox1.Text='podle zadn' then Citac:=0;
    if Combobox1.Text='bisekce pomalu ale jist koen zatkajc' then Citac:=1;
    if Combobox1.Text='pan Newton hezky pracujc' then Citac:=11;
    if Combobox1.Text='pan Newton dobrch rad pana Fouriera nedbajc' then Citac:=12;
    if Combobox1.Text='pan Newton na vbr nemajc' then Citac:=13;
    if Combobox1.Text='pan Newton nespn koen oblhajc' then Citac:=14;
    if Combobox1.Text='pan Newton marn kmitajc' then Citac:=15;
    if Combobox1.Text='pan Newton do osy marn buc' then Citac:=16;
    if Combobox1.Text='pan Newton zuby si lmajc' then  Citac:=17;
    if Combobox1.Text='pan Newton nov chrup zkouejc' then  Citac:=18;
    if Combobox1.Text='seny kontroly znamnek nedbajc' then Citac:=19;
    if Combobox1.Text='regula falsi sprintujc' then Citac:=20;
    if Combobox1.Text='regula falsi pozd pichzejc' then Citac:=21;
    if Combobox1.Text='obecn iterace po schodech vystupujc' then Citac:=22;
    if Combobox1.Text='obecn iterace po schodech sestupujc' then Citac:=23;
    if Combobox1.Text='obecn iterace na lep odchzejc' then Citac:=24;
    if Combobox1.Text='obecn iterace koenu smyku utahujc' then Citac:=25;
    if Combobox1.Text='obecn iterace na kolotoi se vozc' then Citac:=26;
    if Combobox1.Text='obecn iterace v pasti vzc' then Citac:=27;
    NumberOfSegments:=800;
    Case Citac of
     0,10:Begin
           f:=EditF.Text;
           With Draw2D do
           begin
           Val(EditX1.Text,x1,Code);
           Val(EditX2.Text,x2,Code);
           Val(EditY1.Text,y1,Code);
           Val(EditY2.Text,y2,Code);
           LabelNula.Visible:=True; LabelX.Visible:=False;
           end;
       end;
     1:Begin
          Editf.Text:='ln(x+4.5)-1';
          f:=Editf.Text;
          With Draw2D do
           begin
           x1:=-4;x2:=6;y1:=-3;y2:=7;
           Str(x1:6:4,Vypis);EditX1.Text:=Vypis;
           Str(x2:6:4,Vypis);EditX2.Text:=Vypis;
           Str(y1:6:4,Vypis);EditY1.Text:=Vypis;
           Str(y2:6:4,Vypis);EditY2.Text:=Vypis;
           end;
           xx[0]:=-3;xx[1]:=5;
           HorniHranice:=5;
           LabelNula.Visible:=True; LabelX.Visible:=False;
       end;
    11:Begin
           Editf.Text:='0.15*sqrt(x+2)*exp((x-3)/2)-0.1';
           f:=Editf.Text;
           With Draw2D do
           begin
           x1:=-1;x2:=9;y1:=-1;y2:=9;
           Str(x1:6:4,Vypis);EditX1.Text:=Vypis;
           Str(x2:6:4,Vypis);EditX2.Text:=Vypis;
           Str(y1:6:4,Vypis);EditY1.Text:=Vypis;
           Str(y2:6:4,Vypis);EditY2.Text:=Vypis;
           end;
           xx[0]:=8.5;xx[1]:=8.5;
           HorniHranice:=5;
           LabelNula.Visible:=True; LabelX.Visible:=False;
      end;
    12:Begin
           Editf.Text:='-0.5*x+1/(sqr(3*x)+0.01)-0.4';
           f:=Editf.Text;
           With Draw2D do
           begin
           x1:=-4;x2:=4;y1:=-4;y2:=4;
           Str(x1,Vypis);EditX1.Text:=Vypis;
           Str(x2,Vypis);EditX2.Text:=Vypis;
           Str(y1,Vypis);EditY1.Text:=Vypis;
           Str(y2,Vypis);EditY2.Text:=Vypis;
           end;
           xx[0]:=2;xx[1]:=2;
           HorniHranice:=10;
           LabelNula.Visible:=True; LabelX.Visible:=False;
      end;
    13,14,15:Begin
           Editf.Text:='0.02*x+arctan(x-0.5)+0.3';
           f:=Editf.Text;
           With Draw2D do
           begin
           x1:=-5;x2:=5;y1:=-2;y2:=2;
           Str(x1,Vypis);EditX1.Text:=Vypis;
           Str(x2,Vypis);EditX2.Text:=Vypis;
           Str(y1,Vypis);EditY1.Text:=Vypis;
           Str(y2,Vypis);EditY2.Text:=Vypis;
           end;
           xx[0]:=2;xx[1]:=2;
           HorniHranice:=30;
           LabelNula.Visible:=True; LabelX.Visible:=False;
      end;
      16:Begin
           Editf.Text:='25*sgn(x+2)*x*sqrt(5*abs(x+2))-200';
           f:=Editf.Text;
           With Draw2D do
           begin
           x1:=-4;x2:=4;y1:=-320;y2:=50;
           Str(x1,Vypis);EditX1.Text:=Vypis;
           Str(x2,Vypis);EditX2.Text:=Vypis;
           Str(y1,Vypis);EditY1.Text:=Vypis;
           Str(y2,Vypis);EditY2.Text:=Vypis;
           end;
           xx[0]:=-2;xx[1]:=-2;
           HorniHranice:=50;
           LabelNula.Visible:=True; LabelX.Visible:=False;
      end;
      17,18:Begin
           Editf.Text:='(x+0.0035)+20*(x+0.0035)^2*sin(1/5/(x+0.0035))';
           f:=Editf.Text;
           With Draw2D do
           begin
           x1:=-0.004;x2:=0.04001;y1:=-0.004;y2:=0.040;
           Str(x1,Vypis);EditX1.Text:=Vypis;
           Str(x2,Vypis);EditX2.Text:=Vypis;
           Str(y1,Vypis);EditY1.Text:=Vypis;
           Str(y2,Vypis);EditY2.Text:=Vypis;
           end;
           xx[0]:=2;xx[1]:=2;
           HorniHranice:=50;
           LabelNula.Visible:=True; LabelX.Visible:=False;
      end;

     19:Begin
           Editf.Text:='5/sqr(x+3.1)*ln(x+3.5)';
           f:=Editf.Text;
           With Draw2D do
           begin
           x1:=-3.05;x2:=15;y1:=-10;y2:=2;
           Str(x1,Vypis);EditX1.Text:=Vypis;
           Str(x2,Vypis);EditX2.Text:=Vypis;
           Str(y1,Vypis);EditY1.Text:=Vypis;
           Str(y2,Vypis);EditY2.Text:=Vypis;
           end;
           HorniHranice:=20;
           LabelNula.Visible:=True; LabelX.Visible:=False;
      end;
     20:Begin
           Editf.Text:='0.02*x+arctan(x-0.5)+0.3';
           f:=Editf.Text;
           With Draw2D do
           begin
           x1:=-5;x2:=5;y1:=-2;y2:=2;
           Str(x1,Vypis);EditX1.Text:=Vypis;
           Str(x2,Vypis);EditX2.Text:=Vypis;
           Str(y1,Vypis);EditY1.Text:=Vypis;
           Str(y2,Vypis);EditY2.Text:=Vypis;
           end;
           HorniHranice:=10;
           LabelNula.Visible:=True; LabelX.Visible:=False;
      end;
      21:Begin
           Editf.Text:='5/sqr(x+3.1)*ln(x+3.5)';
           
           f:=Editf.Text;
           With Draw2D do
           begin
           x1:=-3.05;x2:=15;y1:=-10;y2:=2;
           Str(x1,Vypis);EditX1.Text:=Vypis;
           Str(x2,Vypis);EditX2.Text:=Vypis;
           Str(y1,Vypis);EditY1.Text:=Vypis;
           Str(y2,Vypis);EditY2.Text:=Vypis;
           end;
           HorniHranice:=10;
           LabelNula.Visible:=True; LabelX.Visible:=False;
      end;
      22:Begin
           Editf.Text:='(5+x^2)^(49/100)';
           f:=Editf.Text;
           With Draw2D do
           begin
           x1:=-1;x2:=9;y1:=-1;y2:=9;
           Str(x1,Vypis);EditX1.Text:=Vypis;
           Str(x2,Vypis);EditX2.Text:=Vypis;
           Str(y1,Vypis);EditY1.Text:=Vypis;
           Str(y2,Vypis);EditY2.Text:=Vypis;
           end;
           HorniHranice:=15;
           LabelNula.Visible:=False; LabelX.Visible:=True;
      end;
     23:Begin
           Editf.Text:='(5+x^2)^(49/100)-2';
           f:=Editf.Text;
           With Draw2D do
           begin
           x1:=-1;x2:=9;y1:=-1;y2:=9;
           Str(x1,Vypis);EditX1.Text:=Vypis;
           Str(x2,Vypis);EditX2.Text:=Vypis;
           Str(y1,Vypis);EditY1.Text:=Vypis;
           Str(y2,Vypis);EditY2.Text:=Vypis;
           end;
           HorniHranice:=15;
           LabelNula.Visible:=False; LabelX.Visible:=True;
      end;
     24:Begin
           Editf.Text:='-0.01*(x-5)^4+0.5*x+4';
           //Editf.Text:='0.01*(x-5)^4+x-2.5';
           f:=Editf.Text;
           With Draw2D do
           begin
           x1:=-1;x2:=9;y1:=-1;y2:=9;
           Str(x1,Vypis);EditX1.Text:=Vypis;
           Str(x2,Vypis);EditX2.Text:=Vypis;
           Str(y1,Vypis);EditY1.Text:=Vypis;
           Str(y2,Vypis);EditY2.Text:=Vypis;
           end;
           HorniHranice:=15;
           LabelNula.Visible:=False; LabelX.Visible:=True;
      end;
      25:Begin
           Editf.Text:='0.00008*((x-17)^4+x)-0.5';
           f:=Editf.Text;
           With Draw2D do
           begin
           x1:=-1;x2:=9;y1:=-1;y2:=9;
           Str(x1,Vypis);EditX1.Text:=Vypis;
           Str(x2,Vypis);EditX2.Text:=Vypis;
           Str(y1,Vypis);EditY1.Text:=Vypis;
           Str(y2,Vypis);EditY2.Text:=Vypis;
           end;
           HorniHranice:=30;
           LabelNula.Visible:=False; LabelX.Visible:=True;
      end;
     26:Begin
           Editf.Text:='0.0001*((x-17)^4+x)-0.5';
           f:=Editf.Text;
           With Draw2D do
           begin
           x1:=-1;x2:=9;y1:=-1;y2:=9;
           Str(x1,Vypis);EditX1.Text:=Vypis;
           Str(x2,Vypis);EditX2.Text:=Vypis;
           Str(y1,Vypis);EditY1.Text:=Vypis;
           Str(y2,Vypis);EditY2.Text:=Vypis;
           end;
           HorniHranice:=15;
           LabelNula.Visible:=False; LabelX.Visible:=True;
      end;
     27:Begin
          Editf.Text:='sqrt(0.02+1.4*(x-5)^2)';
          // Editf.Text:='sqrt(1+1.4*(x-5)^2)';
           f:=Editf.Text;
           With Draw2D do
           begin
           x1:=-1;x2:=9;y1:=-1;y2:=9;
           Str(x1,Vypis);EditX1.Text:=Vypis;
           Str(x2,Vypis);EditX2.Text:=Vypis;
           Str(y1,Vypis);EditY1.Text:=Vypis;
           Str(y2,Vypis);EditY2.Text:=Vypis;
           end;
           HorniHranice:=50;
           LabelNula.Visible:=False; LabelX.Visible:=True;
      end;
   end;
end;

procedure Nereseny_Graf;
 var i,Code :Integer;
  begin
   Control_Panel.Setting;
   With Draw2D do
   begin
    ClearImage(255,255,255);
    Scale(x1,x2,y1,y2);
    With Image1.Canvas do
    begin
      Pen.Width:=1;Font.Color:=Color;Font.Height:=10;
    end;
    XScale(x1,x2,0,255,0,0);YScale(y1,y2,0,255,0,0);
   {konstrukce krivky jako lomene cary}
   hx:=(x2-x1)/NumberOfSegments;
   x:=x1;i:=-1;
   Expression:=PreCalc(f,Error);
    Repeat
      i:=succ(i);
      P[i,1]:=x;
      P[i,2]:=PostCalc(Expression,Error);
      if Error<>'' then
            begin messagedlg(Error,mterror,[mbok],0);exit;end;
      x:=x+hx
    Until x>x2;
    PolyLine(P,i,Red,Green,Blue);
    Image1.Repaint;
  end;
end;

Function Derivace(Expression:TExpression):Double;
Const h=1e-10;
var Suplik:Double;
    h1,h2:Double;
    Error:String;
begin
 Suplik:=Draw2D.x;
 h1:=Draw2D.PostCalc(Expression, Error);
 Draw2D.x:=Draw2D.x-h;
 h2:=(h1-Draw2D.PostCalc(Expression, Error))/h;
 Draw2D.x:=Suplik;
 Derivace:=h2;
end;

Procedure KrokPuleni(aa,bb:Double;var ccc,ddd:Double);
var AP,BP,CP,AcP,BcP,CcP:TPixel;
    ZnA,ZnB,i :Integer;
begin
 With Draw2D do
 begin
  AP[1]:=XCoor(aa); Ap[2]:=YCoor(0)-20;
  AcP[1]:=XCoor(bb);Acp[2]:=YCoor(0)-20;
  Image1.Canvas.Pen.Mode:=pmCopy;
  Image1.Canvas.Pen.Width:=1;
  Image1.Canvas.Pen.Color:=clRed;
  Image1.Canvas.MoveTo(AP[1],AP[2]);
  Image1.Canvas.LineTo(AP[1],AP[2]+70);
  Image1.Canvas.MoveTo(AcP[1],AcP[2]);
  Image1.Canvas.LineTo(AcP[1],AcP[2]+70);
  BP[1]:=Ap[1]-15;CP[1]:=Ap[1]-15;
  BP[2]:=Ap[2]-5; CP[2]:=Ap[2]+5;
  BcP[1]:=Acp[1]+15;CcP[1]:=Acp[1]+15;
  BcP[2]:=Acp[2]-5; CcP[2]:=Acp[2]+5;
  A[1]:=InvXCoor(AP[1]);A[2]:=InvYCoor(AP[2]+50);
  B[1]:=InvXCoor(BP[1]);B[2]:=InvYCoor(BP[2]+50);
  C[1]:=InvXCoor(CP[1]);C[2]:=InvYCoor(CP[2]+50);
  Ac[1]:=InvXCoor(AcP[1]);Ac[2]:=InvYCoor(AcP[2]+50);
  Bc[1]:=InvXCoor(BcP[1]);Bc[2]:=InvYCoor(BcP[2]+50);
  Cc[1]:=InvXCoor(CcP[1]);Cc[2]:=InvYCoor(CcP[2]+50);
  Image1.Repaint;
  Sleep(800);
  Image1.Canvas.Pen.Mode:=pmNotXor;
  Image1.Canvas.Pen.Width:=2;
  cvTriangle(A,B,C,0,150,0);
  cvTriangle(Ac,Bc,Cc,0,150,0);
  hx:=0.01;
  for i:=1 to 49 do
    begin
      Image1.Repaint;
      Sleep(30);
      cvTriangle(A,B,C,0,150,0);
      cvTriangle(Ac,Bc,Cc,0,150,0);
      Image1.Repaint;
      Sleep(30);
    end;
  Repeat
    A[1]:=A[1]+hx;B[1]:=B[1]+hx;C[1]:=C[1]+hx;
    Ac[1]:=Ac[1]-hx;Bc[1]:=Bc[1]-hx;Cc[1]:=Cc[1]-hx;
    cvTriangle(A,B,C,0,150,0);
    cvTriangle(Ac,Bc,Cc,0,150,0);
    Image1.Repaint;
    cvTriangle(A,B,C,0,150,0);
    cvTriangle(Ac,Bc,Cc,0,150,0);
  until A[1]>Ac[1];
  x:=aa;
  if PostCalc(Expression,Error)>0 then ZnA:=1
                                  else ZnA:=-1;
  x:=(aa+bb)/2;
  if PostCalc(Expression,Error)>0 then ZnB:=1
                                  else ZnB:=-1;
  if ZnA*ZnB<0 then begin ccc:=aa;ddd:=x; end
               else begin ccc:=x;ddd:=bb;end;
  Image1.Canvas.Pen.Mode:=pmCopy;
  Image1.Canvas.Pen.Width:=1;
  Image1.Canvas.Pen.Color:=clRed;
  AP[1]:=XCoor(x); Ap[2]:=YCoor(0)-20;
  Image1.Canvas.MoveTo(AP[1],AP[2]);
  Image1.Canvas.LineTo(AP[1],AP[2]+70);
  Image1.REpaint;
 end;
end;

Procedure KrokNewton(aa,bb:Double);
var i:Integer;
begin
 With Draw2D do
 begin
 x:=bb;
 A[1]:=bb;A[2]:=postCalc(Expression,Error);
 B[1]:=bb;B[2]:=0;
 Image1.Canvas.Pen.Style:=psDot;
 cvLine(A,B,200,0,0);
 B[1]:=aa;B[2]:=0;

  Image1.Canvas.Pen.Style:=psSolid;
  Image1.Canvas.Pen.Mode:=pmNotXor;
  Image1.Canvas.Pen.Width:=2;
  Image1.Repaint;
  sleep(1000);
  for i:=1 to 16 do
  begin
  cvLine(A,B,150,0,150);
  Image1.REpaint;
  Sleep(50);
  end;
  Image1.Canvas.Pen.Mode:=pmCopy;
  Image1.Canvas.Pen.Width:=1;
  cvLine(A,B,0,150,0);
  Image1.REpaint;
  Sleep(1000);
end;
end;

Procedure Kroksecny(aa,bb:Double;var ccc:Double);
var i:Integer;
begin
  With Draw2D do
  begin
  Image1.Canvas.Pen.Style:=psDot;
  x:=aa;
  A[1]:=x;A[2]:=postCalc(Expression,Error);
  B:=A;B[2]:=0;
  cvLine(A,B,200,0,0);
  x:=bb;
  A[1]:=x;A[2]:=postCalc(Expression,Error);
  B:=A;B[2]:=0;
  cvLine(A,B,200,0,0);
  x:=aa;
  A[1]:=x;A[2]:=postCalc(Expression,Error);
  x:=bb;
  B[1]:=x;B[2]:=postCalc(Expression,Error);

  Image1.Canvas.Pen.Style:=psSolid;
  Image1.Canvas.Pen.Width:=2;
  Image1.Repaint;
  sleep(1000);
  for i:=1 to 16 do
  begin
  cvLine(A,B,255,255,255);
  Image1.REpaint;
  Sleep(50);
  cvLine(A,B,150,0,150);
  Image1.REpaint;
  Sleep(50);
  end;
  Image1.Canvas.Pen.Mode:=pmCopy;
  Image1.Canvas.Pen.Width:=1;
  cvLine(A,B,0,150,0);
  Image1.REpaint;
  Sleep(1000);
  k:=(B[2]-A[2])/(bb-aa);
  ccc:=bb-B[2]/k;
 end;
end;

Procedure KrokRegula(aa,bb:Double;var ccc,ddd:Double);
var ZnA,ZnB,i:Integer;
    f1,f2,Dalsi:Double;
begin
  With Draw2D do
  begin
  Image1.Canvas.Pen.Style:=psDot;
  x:=aa;
  A[1]:=x;A[2]:=postCalc(Expression,Error);
  B:=A;B[2]:=0;
  cvLine(A,B,200,0,0);
  x:=bb;
  A[1]:=x;A[2]:=postCalc(Expression,Error);
  B:=A;B[2]:=0;
  cvLine(A,B,200,0,0);
  x:=aa;
  A[1]:=x;A[2]:=postCalc(Expression,Error);
  x:=bb;
  B[1]:=x;B[2]:=postCalc(Expression,Error);

  Image1.Canvas.Pen.Style:=psSolid;
  Image1.Canvas.Pen.Mode:=pmNotXor;
  Image1.Canvas.Pen.Width:=2;
  Image1.Repaint;
  sleep(1000);
  for i:=1 to 16 do
  begin
  cvLine(A,B,150,0,150);
  Image1.REpaint;
  Sleep(50);
  end;
  Image1.Canvas.Pen.Mode:=pmCopy;
  Image1.Canvas.Pen.Width:=1;
  cvLine(A,B,0,150,0);
  Image1.REpaint;
  Sleep(1000);

  k:=(B[2]-A[2])/(bb-aa);
  Dalsi:=bb-B[2]/k;
  x:=aa;
  if PostCalc(Expression,Error)>0 then ZnA:=1
                                  else ZnA:=-1;
  x:=Dalsi;
  if PostCalc(Expression,Error)>0 then ZnB:=1
                                  else ZnB:=-1;
  if ZnA*ZnB<0 then begin ccc:=aa;ddd:=x; end
               else begin ccc:=x;ddd:=bb;end;
  end;
end;

Procedure KrokObecIt(aa:Double;var bb:Double);
var Alfa:Double;
    M   :TMatrix;
    i   :Integer;
begin
  With Draw2D do
  begin
    x:=aa;
    bb:=PostCalc(Expression,Error);
    A[1]:=aa;A[2]:=0;B[1]:=aa;B[2]:=bb;
    Image1.Canvas.Pen.Width:=1;
    cvLine(A,B,0,150,0);
    Image1.Canvas.Pen.Mode:=pmNotXor;
    cvLine(A,B,0,150,0);
    Alfa:=0.005;
    Repeat
        cvLine(A,B,0,150,0);
        A[1]:=A[1]-Alfa;B[1]:=B[1]-Alfa;
        cvLine(A,B,0,150,0);
        Image1.REpaint;
    Until A[1]<0;
    Image1.Canvas.Pen.Mode:=pmCopy;
    Image1.Canvas.Pen.Width:=2;
    cvLine(A,B,0,150,0);
    A[1]:=0;B[1]:=0;
    Image1.Repaint;
    Sleep(500);
    Alfa:=-pi/180/4;
    Rot(Alfa,M);
    Image1.Canvas.Pen.Mode:=pmNotXor;
    Sleep(500);
    For i:=1 to 360 do
    begin
     TransOfPoint(B,M,Bc);
     cvLine(A,Bc,0,150,0);
     Image1.Repaint;
     cvLine(A,Bc,0,150,0);
     b:=Bc;
    end;
    Image1.Canvas.Pen.Mode:=pmCopy;
    cvLine(A,Bc,0,150,0);
    Image1.Repaint;
  end;
end;

Procedure PuleniZatyk;
begin
  xx[0]:=-3;xx[1]:=5;
  HorniHranice:=7;
  Draw2D.k:=Derivace(Expression);
end;

Procedure NewtonHezky;
begin
  xx[0]:=8.5;xx[1]:=8.5;
  HorniHranice:=5;
  Draw2D.k:=Derivace(Expression);
end;

Procedure NewtonNedbaj;
begin
  xx[0]:=1.9;xx[1]:=1.9;
  HorniHranice:=30;
  Draw2D.k:=Derivace(Expression);
end;

Procedure NewtonNemaj;
begin
  xx[0]:=1.764236611;xx[1]:=1.764236611;
  HorniHranice:=20;
  Draw2D.k:=Derivace(Expression);
end;

Procedure NewtonObleh;
begin
  xx[0]:=1.7642366115;xx[1]:=1.7642366115;
  HorniHranice:=20;
  Draw2D.k:=Derivace(Expression);
end;

Procedure NewtonKmit;
begin
  xx[0]:=1.7642366114;xx[1]:=1.7642366114;
  Draw2D.x:=xx[1];
  HorniHranice:=30;
  Draw2D.k:=Derivace(Expression);
  //Draw2D.k:=0.404867;
end;

Procedure NewtonBus;
begin
  xx[0]:=-2;xx[1]:=-2;
  HorniHranice:=10;
  Draw2D.k:=1e12;
end;

Procedure NewtonZubyLam;
begin
  xx[0]:=0.01535;xx[1]:=0.01535;
  HorniHranice:=30;
  Draw2D.k:=Derivace(Expression);
end;

Procedure NewtonNovyChrup;
begin
  xx[0]:=0.019;xx[1]:=0.019;
  HorniHranice:=20;
end;

Procedure SecnyNedbaj;
begin
  xx[0]:=-2.73;xx[1]:=-1;
  HorniHranice:=10;
end;

Procedure RegulaSprint;
begin
  xx[0]:=-4;xx[1]:=4;
  HorniHranice:=5;
end;

Procedure RegulaPozde;
begin
  yy[0]:=-2.73;yy[1]:=14;
  xx[0]:=-2.73;xx[1]:=14;
  HorniHranice:=40;
end;

Procedure ObecItNahoru;
begin
  xx[0]:=1;xx[1]:=1;
  HorniHranice:=10;
end;

Procedure ObecItDolu;
begin
  xx[0]:=8;xx[1]:=8;
  HorniHranice:=10;
end;

Procedure ObecItNaLepsi;
begin
  xx[0]:=0.65;xx[1]:=0.65;
  HorniHranice:=7;
end;

Procedure ObecItUtahuj;
begin
  xx[0]:=0.65;xx[1]:=0.65;
  HorniHranice:=7;
end;

Procedure ObecItKolotoc;
begin
  xx[0]:=0.65;xx[1]:=0.65;
  HorniHranice:=20;
end;

Procedure ObecItPast;
begin
  xx[0]:=2.7;xx[1]:=2.7;
  HorniHranice:=300;
end;

procedure TControl_Panel.FormCreate(Sender: TObject);
begin
  Application.CreateForm(TDraw2D, Draw2D);
  With Draw2D do
  begin
    ClientWidth:=650;ClientHeight:=650;
    InitImage(650,650);ClearImage(255,255,255);
    Caption:='Function y=f(x)';
    Visible:=True;
    Blue:=200;Green:=0;Red:=0;
  end;
  LabelX.Visible:=False;LabelNula.Visible:=True;
  Setting;
  Nereseny_Graf;
end;

procedure TControl_Panel.Ukaz_Graf(Sender: TObject);
begin
 Application.ProcessMessages;
 Nereseny_Graf;
end;

procedure TControl_Panel.Pocitej(Sender: TObject);
var i:Integer;

begin
  Setting;
  Stop:=False;
  Nereseny_Graf;
  Case Citac of
        1:PuleniZatyk;
       11:NewtonHezky;
       12:NewtonNedbaj;
       13:NewtonNemaj;
       14:NewtonObleh;
       15:NewtonKmit;
       16:NewtonBus;
       17:NewtonZubyLam;
       18:NewtonNovyChrup;
       19:SecnyNedbaj;
       20:RegulaSprint;
       21:RegulaPozde;
       22:begin
           With Draw2D do
           begin
             A[1]:=-0.5;A[2]:=-0.5;B[1]:=8;B[2]:=8;
             cvLine(A,B,0,0,200);
             Image1.Repaint;
             Sleep(1000);
           end;
           ObecItNahoru;
          end;
        23:begin
           With Draw2D do
           begin
             A[1]:=-0.5;A[2]:=-0.5;B[1]:=8;B[2]:=8;
             cvLine(A,B,0,0,200);
             Image1.Repaint;
             Sleep(1000);
           end;
           ObecItDolu;
          end;
        24:begin
           With Draw2D do
           begin
             A[1]:=-0.5;A[2]:=-0.5;B[1]:=8;B[2]:=8;
             cvLine(A,B,0,0,200);
             Image1.Repaint;
             Sleep(1000);
           end;
           ObecItNaLepsi;
          end;
        25:begin
           With Draw2D do
           begin
             A[1]:=-0.5;A[2]:=-0.5;B[1]:=8;B[2]:=8;
             cvLine(A,B,0,0,200);
             Image1.Repaint;
             Sleep(1000);
           end;
           ObecItUtahuj;
          end;
         26:begin
           With Draw2D do
           begin
             A[1]:=-0.5;A[2]:=-0.5;B[1]:=8;B[2]:=8;
             cvLine(A,B,0,0,200);
             Image1.Repaint;
             Sleep(1000);
           end;
           ObecItKolotoc;
          end;
        27:begin
           With Draw2D do
           begin
             A[1]:=-0.5;A[2]:=-0.5;B[1]:=8;B[2]:=8;
             cvLine(A,B,0,0,200);
             Image1.Repaint;
             Sleep(1000);
           end;
           ObecItPast;
          end;
       end;

  Expression:=Draw2D.Precalc(f,Error);
  Draw2D.x:=xx[0];
  Draw2D.k:=Derivace(Expression);
  for i:=1 to HorniHranice do
  With Draw2D do
  begin
    Application.ProcessMessages;
    if stop then exit;
    x:=xx[i];
    Case Citac of
       1:begin KrokPuleni(xx[i-1],xx[i],PulA,PulB);
               if PulA=xx[i-1] then begin xx[i]:=xx[i-1];xx[i+1]:=PulB;end
                               else begin xx[i]:=PulA;xx[i+1]:=PulB;end;
          end;
       11:begin NewtonHezky;
                xx[i+1]:=xx[i]-postCalc(Expression,Error)/k;
                KrokNewton(xx[i+1],xx[i]);end;
       12:begin NewtonNedbaj;
                xx[i+1]:=xx[i]-postCalc(Expression,Error)/k;
                KrokNewton(xx[i+1],xx[i]);end;
       13:begin NewtonNemaj;
                 xx[i+1]:=xx[i]-postCalc(Expression,Error)/k;
                KrokNewton(xx[i+1],xx[i]);end;
       14:begin NewtonObleh;
                 xx[i+1]:=xx[i]-postCalc(Expression,Error)/k;
               KrokNewton(xx[i+1],xx[i]);end;
       15:begin NewtonKmit;
                 xx[i+1]:=xx[i]-postCalc(Expression,Error)/k;
                KrokNewton(xx[i+1],xx[i]);end;
       16:begin NewtonBus;
                 xx[i+1]:=xx[i]-postCalc(Expression,Error)/k;
                KrokNewton(xx[i+1],xx[i]);end;
       17:begin NewtonZubyLam;
                 xx[i+1]:=xx[i]-postCalc(Expression,Error)/k;
                KrokNewton(xx[i+1],xx[i]);end;
       18:begin NewtonNovyChrup;
                 xx[i+1]:=xx[i]-postCalc(Expression,Error)/k;
                KrokNewton(xx[i+1],xx[i]);end;
       19:KrokSecny(xx[i-1],xx[i],xx[i+1]);
       20:begin KrokRegula(xx[i-1],xx[i],PulA,PulB);
                if PulA=xx[i-1] then begin xx[i]:=xx[i-1];xx[i+1]:=PulB;end
                               else begin xx[i]:=PulA;xx[i+1]:=PulB;end;
          end;
       21:begin KrokRegula(xx[i-1],xx[i],PulA,PulB);
                if PulA=xx[i-1] then begin xx[i]:=xx[i-1];xx[i+1]:=PulB;end
                               else begin xx[i]:=PulA;xx[i+1]:=PulB;end;
                if i<10
                then begin
                      KrokPuleni(yy[i-1],yy[i],PulA,PulB);
                      if PulA=yy[i-1] then begin yy[i]:=yy[i-1];yy[i+1]:=PulB;end
                               else begin yy[i]:=PulA;yy[i+1]:=PulB;end;
                     end;
          end;
        22,23,24,25,26:Begin
             x:=xx[i];
             A[1]:=x;A[2]:=0;
             B[1]:=x;B[2]:=PostCalc(Expression,Error);
             Sleep(1000);
             Image1.Canvas.Pen.Width:=1;
             cvLine(A,B,0,150,0);
             Image1.REpaint;
             Sleep(1000);
             Image1.Canvas.Pen.Mode:=pmCopy;
             Image1.Canvas.Pen.Width:=2;
             A[1]:=xx[i-1];A[2]:=xx[i-1];
             B[1]:=xx[i-1];B[2]:=xx[i];
             cvLine(A,B,150,0,0);
             Image1.REpaint;
             Sleep(500);
             A[1]:=xx[i];A[2]:=xx[i];
             cvLine(A,B,150,0,0);
             Image1.REpaint;
             Sleep(500);
             KrokObecIt(xx[i],xx[i+1]);
             end;
          27:Begin
             x:=xx[i];
             A[1]:=x;A[2]:=0;
             B[1]:=x;B[2]:=PostCalc(Expression,Error);
             xx[i+1]:=B[2];
             Sleep(100);
             Image1.Canvas.Pen.Width:=2;
             Image1.Canvas.Pen.Mode:=pmNotXor;
             A[1]:=xx[i-1];A[2]:=xx[i-1];
             B[1]:=xx[i-1];B[2]:=xx[i];
             cvLine(A,B,150,0,0);
             Image1.REpaint;
             Sleep(100);
             C[1]:=xx[i];C[2]:=xx[i];
             cvLine(B,C,150,0,0);
             Image1.REpaint;
             cvLine(A,B,150,0,0);
             cvLine(B,C,150,0,0);
             Sleep(100);
             Image1.Canvas.Pen.Width:=1;
             Image1.Canvas.Pen.Mode:=pmCopy;
             A[1]:=xx[i-1];A[2]:=xx[i-1];
             B[1]:=xx[i-1];B[2]:=xx[i];
             cvLine(A,B,0,255,0);
             A[1]:=xx[i];A[2]:=xx[i];
             cvLine(A,B,0,255,0);
             Image1.REpaint;
             end;
       end;
   end;
end;


procedure TControl_Panel.Button3Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TControl_Panel.Button4Click(Sender: TObject);
begin
  Stop:=True;
end;

end.
